if rn==nil then rn={} end
function init(a,b)
local array = {}
for i = 1, a do
array[i] = b
end
return array
end
function rn.add(id,case,name,replace,usgn)
	for _,u in pairs(usgn) do
		if id~=nil and case~=nil and name~=nil and replace~=nil and usgn~=nil then
			if case=="s" then
				name=tostring(name)
			elseif case=="l" then
				name=tostring(string.lower(name))
			elseif case=="u" then
				name=tostring(string.upper(name))
			else
				error("Failed to add reserved name, ["..case.."] case is not valid.")
			end
			local idname=tostring(player(id,"name"))
			if string.find(idname,name)~=nil then
				if player(id,"usgn")~=u then
					timer(20,"parse","setname "..id.." "..replace)
				end
				local idusgn,idip=player(id,"usgn"),player(id,"ip")
				print(idname.."  #"..idusgn.."  #"..idip.." using reserved name %"..name.."%")
			end
		else
			error("Failed to add reserved name, parameter may be wrong / misplaced / empty.")
		end
	end
end

-- Configurations ------------------------
--[[	PARAMETERS
ID		Do not change it.
CASE TYPE	[...]case scan type. "s" for sensitive, "l" for lower, and "u" for upper.
NAME		I am sincerely hope you know this parameter does.
REPLACE		After *specific player* caught using reserved name, what should Lua rename *specific player* to?
ALLOW USGN	USGN IDs are allowed to use *specific reserved name*.
]]

function rn.setup(id)


	------EXAMPLES------

--[[
		-- SENSITIVE CASE
	rn.add(id,"s","boolean Value","Player",{142503})
	-- Player using name "boolean Value" with not using USGN 142503 will be automatically renamed to "Player"

		-- LOWER CASE
	rn.add(id,"l","boolean Value","Player",{142503})
	-- Player using name "boolean value" with not using USGN 142503 will be automatically renamed to "Player"

		-- UPPER CASE
	rn.add(id,"u","boolean Value","Player",{142503})
	-- Player using name "BOOLEAN VALUE" with not using USGN 142503 will be automatically renamed to "Player"

		-- USGNS
	rn.add(id,"s","boolean Value","Player",({142503,1}))
	-- Player using name "boolean value" with not using USGN 142503 OR 1 will be automatically renamed to "Player"
]]


	rn.add(id,"u","DC","Traitor",{1})
	rn.add(id,"s","DivineDominion","Traitor",{2})
	rn.add(id,"l","mikede","Traitor",{3})
end

addhook("join","rn.join")
function rn.join(id)
	rn.setup(id)
end

addhook("spawn","rn.spawn")
function rn.spawn(id)
	rn.setup(id)
end

addhook("name","rn.rename")
function rn.rename(id)
	timer(20,"rn.setup","id")
end
